function [Y,R,E] = Isomap_1and7(N,k_value,dataset,dir)
%It constructs 2-D Isomap Model for handwritten digits 1 and 7.
% Parameters:
%   N       : the number of samples to load.
%   dataSet : the data set to load from.
%           : can be one of the two values: 'train' and 'test'
%   dir     : data directory; default value is 'data'
%   k       : value of 'k' in Isomap function.

    if nargin < 1
       N  = 2000;
    end         
    if nargin < 3
        dataset = 'train';
    end   
    if nargin < 4
        dir = 'data';
    end
    
    [data,labels] = loadDigits(N,dataset,dir);
    new_data = zeros(784,N);                                               %new data set having only elements of label 1 and 7
    new_label = zeros(1,N);
    j  = 1;
    for i=1:N
       if labels(:,i) == 1 ||labels(:,i) == 7
          new_data(:,j) = data(:,i);
          new_label(1,j) = labels(1,i);
          j = j+1;
       end
    end
   

   new_data = new_data(:,1:j-1);
   new_label = new_label(1,1:j-1);
   d = L2_distance(new_data,new_data,0);
   options.dims = 1:10;
   [Y,R,E] = Isomap(d,'k',k_value,options);
   
   X1.coords = cell(10,1);
   X2.coords = cell(10,1);
   Y1.coords = cell(10,1);
   Y2.coords = cell(10,1);   
   m = 1; n = 1;
   s = 1; t = 1;
   count = 0; count1 = 0;
   
   for k = 1:j-1
       if new_label(1,k) == 1 
           if mod(count, 40) == 0                                          %storing labels of 1 after 40 intervals
               for i = 1:10
                   X1.coords{i}(1:i,m) = Y.coords{i}(1:i,k);
               end
               X1.coords{11}(:,m) = new_data(:,k);
               m = m+1;
           else 
               for i = 1:10                                                %storing other elements of label 1
                   Y1.coords{i}(1:i,s) = Y.coords{i}(1:i,k);
               end
               Y1.coords{11}(:,s) = new_data(:,k);
               s = s+1;
          end    
           count = count +1;
       end
       
       if new_label(1,k) == 7 
           if mod(count1, 40) == 0                                         %storing labels of 7 after 40 intervals
               for i = 1:10
                   X2.coords{i}(1:i,n) = Y.coords{i}(k);
               end
               X2.coords{11}(:,n) = new_data(:,k);
               n = n + 1;
           else
               for i = 1:10                                                %storing other elements of label 7
                   Y2.coords{i}(1:i,t) = Y.coords{i}(1:i,k);
               end
               Y2.coords{11}(:,t) = new_data(:,k);
               t = t+1;
          end            
          count1 = count1 +1;
       end
   end
   data = cell(5,1);
   data{1} = Y;
   data{2} = X1;
   data{3} = X2;
   data{4} = Y1;
   data{5} = Y2;   
   PlotGraph_1and7(data);
end
   