function [Y,R,E] = Isomap_all(N,k_value,dataset,dir)
%It constructs 2-D Isomap Model for handwritten all the digits between 0 and 9.
% Parameters:
%   N       : the number of samples to load.
%   dataSet : the data set to load from.
%           : can be one of the two values: 'train' and 'test'
%   dir     : data directory; default value is 'data'
%   k       : value of 'k' in Isomap function.
    if nargin < 1
       N  = 2000;
    end   
       
    if nargin < 2
        k_value = 7;
    end
    
    if nargin < 3
        dataset = 'train';
    end
    
    if nargin < 4
        dir = 'data';
    end
   
   [data,labels] = loadDigits(N,dataset,dir); 
   d = L2_distance(data,data,0);
   [Y,R,E] = Isomap(d,'k',k_value,'overlay');
   
   Y0.coords = cell(10,1);
   Y1.coords = cell(10,1);
   Y2.coords = cell(10,1);
   Y3.coords = cell(10,1); 
   Y4.coords = cell(10,1);
   Y5.coords = cell(10,1);
   Y6.coords = cell(10,1);
   Y7.coords = cell(10,1);
   Y8.coords = cell(10,1);
   Y9.coords = cell(10,1);    
   
   s0 = 1; s1 = 1; s2 = 1; s3 = 1; s4 = 1; s5 = 1; s6 = 1; s7 = 1; s8 = 1; s9 = 1;
   
   for k = 1:N
       
       if labels(1,k) == 0 
           for i = 1:10
               Y0.coords{i}(1:i,s0) = Y.coords{i}(1:i,k);
           end
           Y0.coords{11}(:,s0) = data(:,k);
           s0 = s0+1;    
       end
       
       if labels(1,k) == 1 
           for i = 1:10
               Y1.coords{i}(1:i,s1) = Y.coords{i}(1:i,k);
           end
           Y0.coords{11}(:,s1) = data(:,k);
           s1 = s1+1;    
       end
       
       if labels(1,k) == 2 
           for i = 1:10
               Y2.coords{i}(1:i,s2) = Y.coords{i}(1:i,k);
           end
           Y2.coords{11}(:,s2) = data(:,k);
           s2 = s2+1;    
       end      
    
       if labels(1,k) == 3 
           for i = 1:10
               Y3.coords{i}(1:i,s3) = Y.coords{i}(1:i,k);
           end
           Y3.coords{11}(:,s3) = data(:,k);
           s3 = s3+1;    
       end
       
       if labels(1,k) == 4 
           for i = 1:10
               Y4.coords{i}(1:i,s4) = Y.coords{i}(1:i,k);
           end
           Y4.coords{11}(:,s4) = data(:,k);
           s4 = s4+1;    
       end
       
       if labels(1,k) == 5 
           for i = 1:10
               Y5.coords{i}(1:i,s5) = Y.coords{i}(1:i,k);
           end
           Y5.coords{11}(:,s5) = data(:,k);
           s5 = s5+1;    
       end
       
       if labels(1,k) == 6 
           for i = 1:10
               Y6.coords{i}(1:i,s6) = Y.coords{i}(1:i,k);
           end
           Y6.coords{11}(:,s6) = data(:,k);
           s6 = s6+1;    
       end
       
       if labels(1,k) == 7 
           for i = 1:10
               Y7.coords{i}(1:i,s7) = Y.coords{i}(1:i,k);
           end
           Y7.coords{11}(:,s7) = data(:,k);
           s7 = s7+1;    
       end
       
       if labels(1,k) == 8 
           for i = 1:10
               Y8.coords{i}(1:i,s8) = Y.coords{i}(1:i,k);
           end
           Y8.coords{11}(:,s8) = data(:,k);
           s8 = s8+1;    
       end
       
       if labels(1,k) == 9 
           for i = 1:10
               Y9.coords{i}(1:i,s9) = Y.coords{i}(1:i,k);
           end
           Y9.coords{11}(:,s9) = data(:,k);
           s9 = s9+1;    
       end      
       
   end
   data = cell(20,1);
   data{1} = Y0;
   data{2} = Y1;
   data{3} = Y2;
   data{4} = Y3;
   data{5} = Y4;
   data{6} = Y5;
   data{7} = Y6;
   data{8} = Y7;
   data{9} = Y8;  
   data{10} = Y9;
   PlotGraph_all(data);   
end