function Val = PlotGraph_1and7(data, dimLength, dims)
%%%%% Plots two-dimensional configuration %%%%%

  if nargin < 2
      dimLength = [1:10];
  end
  if nargin < 3
      dims = 2;
  end
  numData = size(data);
  numData = numData(1);
   
  twod = dims;
  if ~isempty(twod)
      fig = figure;
      axes1 = axes('Visible', 'on', 'Parent', fig);
      hold on;
      plot(data{4}.coords{twod}(1,:), data{4}.coords{twod}(2,:), 'bo');              %plots elements of data{4} in blue circles
      plot(data{5}.coords{twod}(1,:), data{5}.coords{twod}(2,:), 'go');              %plots elements of data{5} in green circles
      % In X direction
      ImageX = (max(data{1}.coords{twod}(1,:)) - min(data{1}.coords{twod}(1,:)))/10;
      % In Y direction
      ImageY = (max(data{1}.coords{twod}(2,:)) - min(data{1}.coords{twod}(2,:)))/10;
      if numData > 1 
          plot(data{2}.coords{twod}(1,:), data{2}.coords{twod}(2,:), 'b+');           %plots elements of data{2} in blue'+'
          val1 = size(data{2}.coords{twod});
          val1 = val1(1,2);
          for i = 1:val1
              for k=1:28
                  for j = 1:28
                     data1(k,j) = data{2}.coords{11}((k-1)*28 + j,i);
                  end
              end
              Xpoint = data{2}.coords{twod}(1,i);
              Ypoint = data{2}.coords{twod}(2,i);
              colormap('gray');
                 
              image([Xpoint-(ImageX)/5, Xpoint-(ImageX)*6/5],[Ypoint-(ImageY)/5, Ypoint-(ImageY)*6/5],flipdim(data1,1), 'Parent', axes1);
          end
             
      end
      
      if numData > 2 
          plot(data{3}.coords{twod}(1,:), data{3}.coords{twod}(2,:), 'g+');             %plots elements of data32} in green'+'
          val1 = size(data{3}.coords{twod});
          val1 = val1(1,2);
          for i = 1:val1
               for k = 1:28
                   for j = 1:28
                       data1(k,j) = data{3}.coords{11}((k-1)*28 + j,i);
                   end
               end
               Xpoint = data{3}.coords{twod}(1,i);
               Ypoint = data{3}.coords{twod}(2,i);
               colormap('gray');
               image([Xpoint-(ImageX)/5, Xpoint-(ImageX)*6/5],[Ypoint-(ImageY)/5, Ypoint-(ImageY)*6/5],fliplr(data1), 'Parent', axes1);
          end 
      end
         
      title([num2str(dims),'th Dimensional Embedding']);
      hold off;
  end
  val = 1;
end
